Prevent many TC triggered by bad tag expressions
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2019 Cisco and/or its affiliates.
2 # Copyright (c) 2019 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45
46     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
47     case_text="${NODENESS}_${FLAVOR}"
48     case "${case_text}" in
49         "1n_skx" | "1n_tx2")
50             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
51             # script's functions. Env variables are read from ssh output
52             # back to localhost for further processing.
53             hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
54             ssh="ssh root@${hostname} -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # backtics to avoid https://midnight-commander.org/ticket/2142
57             env_vars=`${ssh} "$(declare -f); ${run}"` || {
58                 die "Topology reservation via shim-dcr failed!"
59             }
60             set -a
61             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
62                 die "Source failed!"
63             }
64             set +a
65             ;;
66         "1n_vbox")
67             # We execute reservation on localhost. Sourced script automatially
68             # sets environment variables for further processing.
69             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
70             ;;
71         *)
72             die "Unknown specification: ${case_text}!"
73     esac
74
75     trap 'deactivate_docker_topology' EXIT || {
76          die "Trap attempt failed, please cleanup manually. Aborting!"
77     }
78
79     # Replace all variables in template with those in environment.
80     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
81         die "Topology file create failed!"
82     }
83
84     WORKING_TOPOLOGY="/tmp/topology.yaml"
85     mv topo.yml "${WORKING_TOPOLOGY}" || {
86         die "Topology move failed!"
87     }
88     cat ${WORKING_TOPOLOGY} | grep -v password || {
89         die "Topology read failed!"
90     }
91 }
92
93
94 function activate_virtualenv () {
95
96     # Update virtualenv pip package, delete and create virtualenv directory,
97     # activate the virtualenv, install requirements, set PYTHONPATH.
98
99     # Arguments:
100     # - ${1} - Path to existing directory for creating virtualenv in.
101     #          If missing or empty, ${CSIT_DIR} is used.
102     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
103     # Variables read:
104     # - CSIT_DIR - Path to existing root of local CSIT git repository.
105     # Variables exported:
106     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
107     # Functions called:
108     # - die - Print to stderr and exit.
109
110     set -exuo pipefail
111
112     root_path="${1-$CSIT_DIR}"
113     env_dir="${root_path}/env"
114     req_path=${2-$CSIT_DIR/requirements.txt}
115     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
116     pip install --upgrade virtualenv || {
117         die "Virtualenv package install failed."
118     }
119     virtualenv "${env_dir}" || {
120         die "Virtualenv creation failed."
121     }
122     set +u
123     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
124     set -u
125     pip install --upgrade -r "${req_path}" || {
126         die "Requirements installation failed."
127     }
128     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
129     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
130 }
131
132
133 function archive_tests () {
134
135     # Create .tar.xz of generated/tests for archiving.
136     # To be run after generate_tests, kept separate to offer more flexibility.
137
138     # Directory read:
139     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
140     # File rewriten:
141     # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
142
143     set -exuo pipefail
144
145     tar c "${GENERATED_DIR}/tests" | xz -9e > "${ARCHIVE_DIR}/tests.tar.xz" || {
146         die "Error creating archive of generated tests."
147     }
148 }
149
150
151 function check_download_dir () {
152
153     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
154     #
155     # Variables read:
156     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
157     # Directories read:
158     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
159     # Functions called:
160     # - die - Print to stderr and exit.
161
162     set -exuo pipefail
163
164     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
165         die "No artifacts downloaded!"
166     fi
167 }
168
169
170 function check_prerequisites () {
171
172     # Fail if prerequisites are not met.
173     #
174     # Functions called:
175     # - installed - Check if application is installed/present in system.
176     # - die - Print to stderr and exit.
177
178     set -exuo pipefail
179
180     if ! installed sshpass; then
181         die "Please install sshpass before continue!"
182     fi
183 }
184
185 function cleanup_topo () {
186
187     # Variables read:
188     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
189     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
190
191     set -exuo pipefail
192
193     python "${PYTHON_SCRIPTS_DIR}/topo_cleanup.py" -t "${WORKING_TOPOLOGY}"
194     # Not using "|| die" as some callers might want to ignore errors,
195     # e.g. in teardowns, such as unreserve.
196 }
197
198
199 function common_dirs () {
200
201     # Set global variables, create some directories (without touching content).
202
203     # Variables set:
204     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
205     # - CSIT_DIR - Path to existing root of local CSIT git repository.
206     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
207     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
208     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
209     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
210     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archive".
211     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
212     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
213     # Directories created if not present:
214     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
215     # Functions called:
216     # - die - Print to stderr and exit.
217
218     set -exuo pipefail
219
220     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
221         die "Some error during locating of this source file."
222     }
223     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
224         die "Some error during dirname call."
225     }
226     # Current working directory could be in a different repo, e.g. VPP.
227     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
228     relative_csit_dir=$(git rev-parse --show-toplevel) || {
229         die "Git rev-parse failed."
230     }
231     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
232     popd || die "Popd failed."
233     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
234         die "Readlink failed."
235     }
236     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
237         die "Readlink failed."
238     }
239     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
240         die "Readlink failed."
241     }
242     DOC_GEN_DIR=$(readlink -e "${TOOLS_DIR}/doc_gen") || {
243         die "Readlink failed."
244     }
245     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
246         die "Readlink failed."
247     }
248
249     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archive") || {
250         die "Readlink failed."
251     }
252     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
253     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
254         die "Readlink failed."
255     }
256     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
257     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
258         die "Readlink failed."
259     }
260     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
261 }
262
263
264 function compose_pybot_arguments () {
265
266     # Variables read:
267     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
268     # - DUT - CSIT test/ subdirectory, set while processing tags.
269     # - TAGS - Array variable holding selected tag boolean expressions.
270     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
271     # - TEST_CODE - The test selection string from environment or argument.
272     # Variables set:
273     # - PYBOT_ARGS - String holding part of all arguments for pybot.
274     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
275
276     set -exuo pipefail
277
278     # No explicit check needed with "set -u".
279     PYBOT_ARGS=("--loglevel" "TRACE")
280     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
281
282     case "${TEST_CODE}" in
283         *"device"*)
284             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
285             ;;
286         *"func"*)
287             PYBOT_ARGS+=("--suite" "tests.${DUT}.func")
288             ;;
289         *"perf"*)
290             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
291             ;;
292         *)
293             die "Unknown specification: ${TEST_CODE}"
294     esac
295
296     EXPANDED_TAGS=()
297     for tag in "${TAGS[@]}"; do
298         if [[ ${tag} == "!"* ]]; then
299             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
300         else
301             EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
302         fi
303     done
304 }
305
306
307 function copy_archives () {
308
309     # Create additional archive if workspace variable is set.
310     # This way if script is running in jenkins all will be
311     # automatically archived to logs.fd.io.
312     #
313     # Variables read:
314     # - WORKSPACE - Jenkins workspace, copy only if the value is not empty.
315     #   Can be unset, then it speeds up manual testing.
316     # - ARCHIVE_DIR - Path to directory with content to be copied.
317     # Directories updated:
318     # - ${WORKSPACE}/archives/ - Created if does not exist.
319     #   Content of ${ARCHIVE_DIR}/ is copied here.
320     # Functions called:
321     # - die - Print to stderr and exit.
322
323     set -exuo pipefail
324
325     if [[ -n "${WORKSPACE-}" ]]; then
326         mkdir -p "${WORKSPACE}/archives/" || die "Archives dir create failed."
327         cp -rf "${ARCHIVE_DIR}"/* "${WORKSPACE}/archives" || die "Copy failed."
328     fi
329 }
330
331
332 function deactivate_docker_topology () {
333
334     # Deactivate virtual vpp-device topology by removing containers.
335     #
336     # Variables read:
337     # - NODENESS - Node multiplicity of desired testbed.
338     # - FLAVOR - Node flavor string, usually describing the processor.
339
340     set -exuo pipefail
341
342     case_text="${NODENESS}_${FLAVOR}"
343     case "${case_text}" in
344         "1n_skx" | "1n_tx2")
345             hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
346             ssh="ssh root@${hostname} -p 6022"
347             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
348             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
349                 die "Topology cleanup via shim-dcr failed!"
350             }
351             ;;
352         "1n_vbox")
353             enter_mutex || die
354             clean_environment || {
355                 die "Topology cleanup locally failed!"
356             }
357             exit_mutex || die
358             ;;
359         *)
360             die "Unknown specification: ${case_text}!"
361     esac
362 }
363
364
365 function die () {
366
367     # Print the message to standard error end exit with error code specified
368     # by the second argument.
369     #
370     # Hardcoded values:
371     # - The default error message.
372     # Arguments:
373     # - ${1} - The whole error message, be sure to quote. Optional
374     # - ${2} - the code to exit with, default: 1.
375
376     set -x
377     set +eu
378     warn "${1:-Unspecified run-time error occurred!}"
379     exit "${2:-1}"
380 }
381
382
383 function die_on_pybot_error () {
384
385     # Source this fragment if you want to abort on any failed test case.
386     #
387     # Variables read:
388     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
389     # Functions called:
390     # - die - Print to stderr and exit.
391
392     set -exuo pipefail
393
394     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
395         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
396     fi
397 }
398
399
400 function generate_tests () {
401
402     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
403     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
404     # The generation is done by executing any *.py executable
405     # within any subdirectory after copying.
406
407     # This is a separate function, because this code is called
408     # both by autogen checker and entries calling run_pybot.
409
410     # Directories read:
411     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
412     # Directories replaced:
413     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
414
415     set -exuo pipefail
416
417     rm -rf "${GENERATED_DIR}/tests" || die
418     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
419     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
420     cmd_line+=("-executable" "-name" "*.py")
421     file_list=$("${cmd_line[@]}") || die
422
423     for gen in ${file_list}; do
424         directory="$(dirname "${gen}")" || die
425         filename="$(basename "${gen}")" || die
426         pushd "${directory}" || die
427         ./"${filename}" || die
428         popd || die
429     done
430 }
431
432
433 function get_test_code () {
434
435     # Arguments:
436     # - ${1} - Optional, argument of entry script (or empty as unset).
437     #   Test code value to override job name from environment.
438     # Variables read:
439     # - JOB_NAME - String affecting test selection, default if not argument.
440     # Variables set:
441     # - TEST_CODE - The test selection string from environment or argument.
442     # - NODENESS - Node multiplicity of desired testbed.
443     # - FLAVOR - Node flavor string, usually describing the processor.
444
445     set -exuo pipefail
446
447     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
448     if [[ -z "${TEST_CODE}" ]]; then
449         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
450     fi
451
452     case "${TEST_CODE}" in
453         *"1n-vbox"*)
454             NODENESS="1n"
455             FLAVOR="vbox"
456             ;;
457         *"1n-skx"*)
458             NODENESS="1n"
459             FLAVOR="skx"
460             ;;
461        *"1n-tx2"*)
462             NODENESS="1n"
463             FLAVOR="tx2"
464             ;;
465         *"2n-skx"*)
466             NODENESS="2n"
467             FLAVOR="skx"
468             ;;
469         *"3n-skx"*)
470             NODENESS="3n"
471             FLAVOR="skx"
472             ;;
473         *"2n-clx"*)
474             NODENESS="2n"
475             FLAVOR="clx"
476             ;;
477         *"2n-dnv"*)
478             NODENESS="2n"
479             FLAVOR="dnv"
480             ;;
481         *"3n-dnv"*)
482             NODENESS="3n"
483             FLAVOR="dnv"
484             ;;
485         *"3n-tsh"*)
486             NODENESS="3n"
487             FLAVOR="tsh"
488             ;;
489         *)
490             # Fallback to 3-node Haswell by default (backward compatibility)
491             NODENESS="3n"
492             FLAVOR="hsw"
493             ;;
494     esac
495 }
496
497
498 function get_test_tag_string () {
499
500     # Variables read:
501     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
502     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
503     # - TEST_CODE - The test selection string from environment or argument.
504     # Variables set:
505     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
506     #   May be empty, not set on event types not adding comment.
507
508     # TODO: ci-management scripts no longer need to perform this.
509
510     set -exuo pipefail
511
512     trigger=""
513     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
514         case "${TEST_CODE}" in
515             *"device"*)
516                 # On parsing error, ${trigger} stays empty.
517                 trigger="$(echo "${GERRIT_EVENT_COMMENT_TEXT}" \
518                     | grep -oE '(devicetest$|devicetest[[:space:]].+$)' \
519                     || true)"
520                 # Set test tags as string.
521                 TEST_TAG_STRING="${trigger#$"devicetest"}"
522                 ;;
523             *"perf"*)
524                 # On parsing error, ${trigger} stays empty.
525                 comment="${GERRIT_EVENT_COMMENT_TEXT}"
526                 # As "perftest" can be followed by something, we substitute it.
527                 comment="${comment/perftest-2n/perftest}"
528                 comment="${comment/perftest-3n/perftest}"
529                 comment="${comment/perftest-hsw/perftest}"
530                 comment="${comment/perftest-skx/perftest}"
531                 comment="${comment/perftest-dnv/perftest}"
532                 comment="${comment/perftest-tsh/perftest}"
533                 tag_string="$(echo "${comment}" \
534                     | grep -oE '(perftest$|perftest[[:space:]].+$)' || true)"
535                 # Set test tags as string.
536                 TEST_TAG_STRING="${tag_string#$"perftest"}"
537                 ;;
538             *)
539                 die "Unknown specification: ${TEST_CODE}"
540         esac
541     fi
542 }
543
544
545 function installed () {
546
547     # Check if the given utility is installed. Fail if not installed.
548     #
549     # Duplicate of common.sh function, as this file is also used standalone.
550     #
551     # Arguments:
552     # - ${1} - Utility to check.
553     # Returns:
554     # - 0 - If command is installed.
555     # - 1 - If command is not installed.
556
557     set -exuo pipefail
558
559     command -v "${1}"
560 }
561
562
563 function reserve_and_cleanup_testbed () {
564
565     # Reserve physical testbed, perform cleanup, register trap to unreserve.
566     # When cleanup fails, remove from topologies and keep retrying
567     # until all topologies are removed.
568     #
569     # Variables read:
570     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
571     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
572     # - BUILD_TAG - Any string suitable as filename, identifying
573     #   test run executing this function. May be unset.
574     # Variables set:
575     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
576     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
577     # Functions called:
578     # - die - Print to stderr and exit.
579     # - ansible_hosts - Perform an action using ansible, see ansible.sh
580     # Traps registered:
581     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
582
583     set -exuo pipefail
584
585     while true; do
586         for topo in "${TOPOLOGIES[@]}"; do
587             set +e
588             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
589             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
590             python "${scrpt}" "${opts[@]}"
591             result="$?"
592             set -e
593             if [[ "${result}" == "0" ]]; then
594                 # Trap unreservation before cleanup check,
595                 # so multiple jobs showing failed cleanup improve chances
596                 # of humans to notice and fix.
597                 WORKING_TOPOLOGY="${topo}"
598                 echo "Reserved: ${WORKING_TOPOLOGY}"
599                 trap "untrap_and_unreserve_testbed" EXIT || {
600                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
601                     untrap_and_unreserve_testbed "${message}" || {
602                         die "Teardown should have died, not failed."
603                     }
604                     die "Trap attempt failed, unreserve succeeded. Aborting."
605                 }
606                 # Cleanup check.
607                 set +e
608                 ansible_hosts "cleanup"
609                 result="$?"
610                 set -e
611                 if [[ "${result}" == "0" ]]; then
612                     break
613                 fi
614                 warn "Testbed cleanup failed: ${topo}"
615                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
616             fi
617             # Else testbed is accessible but currently reserved, moving on.
618         done
619
620         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
621             # Exit the infinite while loop if we made a reservation.
622             warn "Reservation and cleanup successful."
623             break
624         fi
625
626         if [[ "${#TOPOLOGIES[@]}" == "0" ]]; then
627             die "Run out of operational testbeds!"
628         fi
629
630         # Wait ~3minutes before next try.
631         sleep_time="$[ ( ${RANDOM} % 20 ) + 180 ]s" || {
632             die "Sleep time calculation failed."
633         }
634         echo "Sleeping ${sleep_time}"
635         sleep "${sleep_time}" || die "Sleep failed."
636     done
637 }
638
639
640 function run_pybot () {
641
642     # Run pybot with options based on input variables. Create output_info.xml
643     #
644     # Variables read:
645     # - CSIT_DIR - Path to existing root of local CSIT git repository.
646     # - ARCHIVE_DIR - Path to store robot result files in.
647     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
648     # - GENERATED_DIR - Tests are assumed to be generated under there.
649     # Variables set:
650     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
651     # Functions called:
652     # - die - Print to stderr and exit.
653
654     set -exuo pipefail
655
656     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
657     all_options+=("--noncritical" "EXPECTED_FAILING")
658     all_options+=("${EXPANDED_TAGS[@]}")
659
660     pushd "${CSIT_DIR}" || die "Change directory operation failed."
661     set +e
662     pybot "${all_options[@]}" "${GENERATED_DIR}/tests/"
663     PYBOT_EXIT_STATUS="$?"
664     set -e
665
666     # Generate INFO level output_info.xml for post-processing.
667     all_options=("--loglevel" "INFO")
668     all_options+=("--log" "none")
669     all_options+=("--report" "none")
670     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
671     all_options+=("${ARCHIVE_DIR}/output.xml")
672     rebot "${all_options[@]}" || true
673     popd || die "Change directory operation failed."
674 }
675
676
677 function select_arch_os () {
678
679     # Set variables affected by local CPU architecture and operating system.
680     #
681     # Variables set:
682     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
683     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
684     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
685
686     set -exuo pipefail
687
688     os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
689         die "Get OS release failed."
690     }
691
692     case "${os_id}" in
693         "ubuntu"*)
694             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
695             VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_BIONIC"
696             PKG_SUFFIX="deb"
697             ;;
698         "centos"*)
699             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_CENTOS"
700             VPP_VER_FILE="VPP_STABLE_VER_CENTOS"
701             PKG_SUFFIX="rpm"
702             ;;
703         *)
704             die "Unable to identify distro or os from ${os_id}"
705             ;;
706     esac
707
708     arch=$(uname -m) || {
709         die "Get CPU architecture failed."
710     }
711
712     case "${arch}" in
713         "aarch64")
714             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
715             ;;
716         *)
717             ;;
718     esac
719 }
720
721
722 function select_tags () {
723
724     # Variables read:
725     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
726     # - TEST_CODE - String affecting test selection, usually jenkins job name.
727     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
728     #   Can be unset.
729     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
730     # - BASH_FUNCTION_DIR - Directory with input files to process.
731     # Variables set:
732     # - TAGS - Array of processed tag boolean expressions.
733
734     set -exuo pipefail
735
736     # NIC SELECTION
737     start_pattern='^  TG:'
738     end_pattern='^ \? \?[A-Za-z0-9]\+:'
739     # Remove the TG section from topology file
740     sed_command="/${start_pattern}/,/${end_pattern}/d"
741     # All topologies DUT NICs
742     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
743                 | grep -hoP "model: \K.*" | sort -u)
744     # Selected topology DUT NICs
745     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
746                | grep -hoP "model: \K.*" | sort -u)
747     # All topologies DUT NICs - Selected topology DUT NICs
748     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
749         die "Computation of excluded NICs failed."
750     }
751
752     # Select default NIC tag.
753     case "${TEST_CODE}" in
754         *"3n-dnv"* | *"2n-dnv"*)
755             default_nic="nic_intel-x553"
756             ;;
757         *"3n-tsh"*)
758             default_nic="nic_intel-x520-da2"
759             ;;
760         *"3n-skx"* | *"2n-skx"* | *"2n-clx"*)
761             default_nic="nic_intel-xxv710"
762             ;;
763         *"3n-hsw"* | *"mrr-daily-master")
764             default_nic="nic_intel-xl710"
765             ;;
766         *)
767             default_nic="nic_intel-x710"
768             ;;
769     esac
770
771     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
772     # Tag file directory shorthand.
773     tfd="${BASH_FUNCTION_DIR}"
774     case "${TEST_CODE}" in
775         # Select specific performance tests based on jenkins job type variable.
776         *"ndrpdr-weekly"* )
777             readarray -t test_tag_array < "${tfd}/mlr-weekly.txt" || die
778             ;;
779         *"mrr-daily"* )
780             readarray -t test_tag_array <<< $(${sed_nic_sub_cmd} \
781                 ${tfd}/mrr-daily-${FLAVOR}.txt) || die
782             ;;
783         *"mrr-weekly"* )
784             readarray -t test_tag_array < "${tfd}/mrr-weekly.txt" || die
785             ;;
786         * )
787             if [[ -z "${TEST_TAG_STRING-}" ]]; then
788                 # If nothing is specified, we will run pre-selected tests by
789                 # following tags.
790                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDip4base"
791                                 "mrrAND${default_nic}AND1cAND78bANDip6base"
792                                 "mrrAND${default_nic}AND1cAND64bANDl2bdbase"
793                                 "mrrAND${default_nic}AND1cAND64bANDl2xcbase"
794                                 "!dot1q" "!drv_avf")
795             else
796                 # If trigger contains tags, split them into array.
797                 test_tag_array=(${TEST_TAG_STRING//:/ })
798             fi
799             ;;
800     esac
801
802     # Blacklisting certain tags per topology.
803     #
804     # Reasons for blacklisting:
805     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
806     # TODO: Add missing reasons here (if general) or where used (if specific).
807     case "${TEST_CODE}" in
808         *"2n-skx"*)
809             test_tag_array+=("!ipsechw")
810             ;;
811         *"3n-skx"*)
812             test_tag_array+=("!ipsechw")
813             # Not enough nic_intel-xxv710 to support double link tests.
814             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
815             ;;
816         *"2n-clx"*)
817             test_tag_array+=("!ipsechw")
818             ;;
819         *"2n-dnv"*)
820             test_tag_array+=("!ipsechw")
821             test_tag_array+=("!memif")
822             test_tag_array+=("!srv6_proxy")
823             test_tag_array+=("!vhost")
824             test_tag_array+=("!vts")
825             test_tag_array+=("!drv_avf")
826             ;;
827         *"3n-dnv"*)
828             test_tag_array+=("!memif")
829             test_tag_array+=("!srv6_proxy")
830             test_tag_array+=("!vhost")
831             test_tag_array+=("!vts")
832             test_tag_array+=("!drv_avf")
833             ;;
834         *"3n-tsh"*)
835             # 3n-tsh only has x520 NICs which don't work with AVF
836             test_tag_array+=("!drv_avf")
837             test_tag_array+=("!ipsechw")
838             ;;
839         *"3n-hsw"*)
840             # TODO: Introduce NOIOMMU version of AVF tests.
841             # TODO: Make (both) AVF tests work on Haswell,
842             # or document why (some of) it is not possible.
843             # https://github.com/FDio/vpp/blob/master/src/plugins/avf/README.md
844             test_tag_array+=("!drv_avf")
845             # All cards have access to QAT. But only one card (xl710)
846             # resides in same NUMA as QAT. Other cards must go over QPI
847             # which we do not want to even run.
848             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
849             ;;
850         *)
851             # Default to 3n-hsw due to compatibility.
852             test_tag_array+=("!drv_avf")
853             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
854             ;;
855     esac
856
857     # We will add excluded NICs.
858     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
859
860     TAGS=()
861
862     # We will prefix with perftest to prevent running other tests
863     # (e.g. Functional).
864     prefix="perftestAND"
865     set +x
866     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
867         # Automatic prefixing for VPP jobs to limit the NIC used and
868         # traffic evaluation to MRR.
869         if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
870             prefix="${prefix}mrrAND"
871         else
872             prefix="${prefix}mrrAND${default_nic}AND"
873         fi
874     fi
875     for tag in "${test_tag_array[@]}"; do
876         if [[ "${tag}" == "!"* ]]; then
877             # Exclude tags are not prefixed.
878             TAGS+=("${tag}")
879         elif [[ "${tag}" == " "* || "${tag}" == *"perftest"* ]]; then
880             # Badly formed tag expressions can trigger way too much tests.
881             set -x
882             warn "The following tag expression hints at bad trigger: ${tag}"
883             warn "Possible cause: Multiple triggers in a single comment."
884             die "Aborting to avoid triggering too many tests."
885         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
886             # Empty and comment lines are skipped.
887             # Other lines are normal tags, they are to be prefixed.
888             TAGS+=("${prefix}${tag}")
889         fi
890     done
891     set -x
892 }
893
894
895 function select_topology () {
896
897     # Variables read:
898     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
899     # - FLAVOR - Node flavor string, currently either "hsw" or "skx".
900     # - CSIT_DIR - Path to existing root of local CSIT git repository.
901     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
902     # Variables set:
903     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
904     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
905     # Functions called:
906     # - die - Print to stderr and exit.
907
908     set -exuo pipefail
909
910     case_text="${NODENESS}_${FLAVOR}"
911     case "${case_text}" in
912         # TODO: Move tags to "# Blacklisting certain tags per topology" section.
913         # TODO: Double link availability depends on NIC used.
914         "1n_vbox")
915             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
916             TOPOLOGIES_TAGS="2_node_single_link_topo"
917             ;;
918         "1n_skx" | "1n_tx2")
919             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
920             TOPOLOGIES_TAGS="2_node_single_link_topo"
921             ;;
922         "2n_skx")
923             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
924             TOPOLOGIES_TAGS="2_node_*_link_topo"
925             ;;
926         "3n_skx")
927             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
928             TOPOLOGIES_TAGS="3_node_*_link_topo"
929             ;;
930         "2n_clx")
931             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_clx*.yaml )
932             TOPOLOGIES_TAGS="2_node_*_link_topo"
933             ;;
934         "2n_dnv")
935             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
936             TOPOLOGIES_TAGS="2_node_single_link_topo"
937             ;;
938         "3n_dnv")
939             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
940             TOPOLOGIES_TAGS="3_node_single_link_topo"
941             ;;
942         "3n_hsw")
943             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_hsw*.yaml )
944             TOPOLOGIES_TAGS="3_node_single_link_topo"
945             ;;
946         "3n_tsh")
947             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
948             TOPOLOGIES_TAGS="3_node_single_link_topo"
949             ;;
950         *)
951             # No falling back to 3n_hsw default, that should have been done
952             # by the function which has set NODENESS and FLAVOR.
953             die "Unknown specification: ${case_text}"
954     esac
955
956     if [[ -z "${TOPOLOGIES-}" ]]; then
957         die "No applicable topology found!"
958     fi
959 }
960
961
962 function select_vpp_device_tags () {
963
964     # Variables read:
965     # - TEST_CODE - String affecting test selection, usually jenkins job name.
966     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
967     #   Can be unset.
968     # Variables set:
969     # - TAGS - Array of processed tag boolean expressions.
970
971     set -exuo pipefail
972
973     case "${TEST_CODE}" in
974         # Select specific device tests based on jenkins job type variable.
975         * )
976             if [[ -z "${TEST_TAG_STRING-}" ]]; then
977                 # If nothing is specified, we will run pre-selected tests by
978                 # following tags. Items of array will be concatenated by OR
979                 # in Robot Framework.
980                 test_tag_array=()
981             else
982                 # If trigger contains tags, split them into array.
983                 test_tag_array=(${TEST_TAG_STRING//:/ })
984             fi
985             ;;
986     esac
987
988     # Blacklisting certain tags per topology.
989     #
990     # Reasons for blacklisting:
991     # - avf - AVF is not possible to run on enic driver of VirtualBox.
992     # - vhost - VirtualBox does not support nesting virtualization on Intel CPU.
993     case "${TEST_CODE}" in
994         *"1n-vbox"*)
995             test_tag_array+=("!avf")
996             test_tag_array+=("!vhost")
997             ;;
998         *)
999             ;;
1000     esac
1001
1002     TAGS=()
1003
1004     # We will prefix with devicetest to prevent running other tests
1005     # (e.g. Functional).
1006     prefix="devicetestAND"
1007     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
1008         # Automatic prefixing for VPP jobs to limit testing.
1009         prefix="${prefix}"
1010     fi
1011     for tag in "${test_tag_array[@]}"; do
1012         if [[ ${tag} == "!"* ]]; then
1013             # Exclude tags are not prefixed.
1014             TAGS+=("${tag}")
1015         else
1016             TAGS+=("${prefix}${tag}")
1017         fi
1018     done
1019 }
1020
1021 function untrap_and_unreserve_testbed () {
1022
1023     # Use this as a trap function to ensure testbed does not remain reserved.
1024     # Perhaps call directly before script exit, to free testbed for other jobs.
1025     # This function is smart enough to avoid multiple unreservations (so safe).
1026     # Topo cleanup is executed (call it best practice), ignoring failures.
1027     #
1028     # Hardcoded values:
1029     # - default message to die with if testbed might remain reserved.
1030     # Arguments:
1031     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1032     # Variables read (by inner function):
1033     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1034     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1035     # Variables written:
1036     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1037     # Trap unregistered:
1038     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1039     # Functions called:
1040     # - die - Print to stderr and exit.
1041     # - ansible_hosts - Perform an action using ansible, see ansible.sh
1042
1043     set -xo pipefail
1044     set +eu  # We do not want to exit early in a "teardown" function.
1045     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1046     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1047     if [[ -z "${wt-}" ]]; then
1048         set -eu
1049         warn "Testbed looks unreserved already. Trap removal failed before?"
1050     else
1051         ansible_hosts "cleanup" || true
1052         python "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1053             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1054         }
1055         WORKING_TOPOLOGY=""
1056         set -eu
1057     fi
1058 }
1059
1060
1061 function warn () {
1062
1063     # Print the message to standard error.
1064     #
1065     # Arguments:
1066     # - ${@} - The text of the message.
1067
1068     set -exuo pipefail
1069
1070     echo "$@" >&2
1071 }